#! /bin/sh 

#
# This script runs a small reference file against itself, the
# same reference against a hyp with no NE tags, and the same
# reference again against a hyp with two or three correct NE
# tags.
#

UTF_FILT=$IEEVAL/scripts/utf_filt
CTM2UTF=$IEEVAL/scripts/ctm2utf.pl
REEP=$IEEVAL/scripts/reep
DTD=$IEEVAL/refdata/utf.dtd 


$UTF_FILT -e $DTD -i example_hub4.utf -o example_hub4.iectm -f iectm
$CTM2UTF -a h4e_97 < example_hub4.iectm > example_hub4.iectm.2.utf
cat  example_hub4.iectm.2.utf | \
    perl -pe 's/<[be]_(enamex|timex|numex)[^<>]*>//gi; ' > \
    example_hub4_100err.ctm.utf
cat  example_hub4.iectm.2.utf | \
    perl -e '$n = 0;
	    while (<>){
		if ($n >= 3){
		    s/<[be]_(enamex|timex|numex)[^<>]*>//gi; 
		    }
		$n++ if (/<e_(enamex|timex|numex)/i);
		print;
	    }' > \
    example_hub4_3corr.ctm.utf

rm -f reep.example_hub4.ref_vs_ref/*
mkdir -p reep.example_hub4.ref_vs_ref
$REEP --ref example_hub4.utf \
    --hyp example_hub4.iectm.2.utf \
    --outdir reep.example_hub4.ref_vs_ref \
    --nocleanup
 
rm -f reep.example_hub4_100err/*
mkdir -p reep.example_hub4_100err
$REEP --ref example_hub4.utf \
    --hyp example_hub4_100err.ctm.utf \
    --outdir reep.example_hub4_100err \
    --nocleanup

rm -f reep.example_hub4_3corr/*
mkdir -p reep.example_hub4_3corr
$REEP --ref example_hub4.utf \
    --hyp example_hub4_3corr.ctm.utf \
    --outdir reep.example_hub4_3corr \
    --nocleanup

