#!/bin/sh -- # -*- perl -*- -w
eval 'exec perl -S $0 ${1+"$@"}'
    if 0;

$ref_state_out = 1;
$hyp_state_out = 1;

@REF = ();
@HYP = ();

$ncorr = 0;

while (<STDIN>){
    if ($_ =~ /<PATH/){
	$pathid=$_;
	$pathid =~ s/sequence=.\d+. //;

	$_ = <STDIN>;
	@p = split(/[:\n]/,$_);
	$rest = "";
	for ($i=0; $i<=$#p; $i++){
	    ($eval, $ref, $hyp, $rest) = split(/,/,$p[$i],4);
	    $ref =~ s/^"(.*)"$/$1/;
	    $hyp =~ s/^"(.*)"$/$1/;

	    set_state(*ref_state_out, $ref, "ref_state");
	    set_state(*hyp_state_out, $hyp, "hyp_state");

	    #print "$ref_state_out $hyp_state_out $p[$i]\n";

	    push (@REF, $ref);
	    push (@HYP, $hyp);
	    
	    if ($eval eq "C"){
		$ncorr ++;	
	    } else {
		$ncorr = 0;
	    }

   	    flush_alignment() if ($ncorr > 3 && 
				  $ref_state_out == 1 &&
				  $hyp_state_out == 1) ;
	}
        $_ = <STDIN>;
    } else {
	;
    }

}

sub flush_alignment{
    printf "ID: (SENTENCE%06d)\n",$sent++;
    print "REF:"; foreach $w(@REF){ print " $w" if ($w ne ""); } print "\n";
    print "HYP:"; foreach $w(@HYP){ print " $w" if ($w ne ""); } print "\n";
    print "\n";
    
    @REF = ();
    @HYP = ();
    
    $ncorr = 0;
}

sub set_state{
    local (*state, $text, $type) = @_;

    if ($state == 1){
	if ($text =~ /^[^<>]*<(timex|numex|enamex)[^>]+>[^<>]*$/){
	    $state = 0;
	} elsif ($text =~ /^[^<>]*<(timex|numex|enamex)[^>]+>[^<>]+<\/(timex|numex|enamex)>[^<>]*$/){
	    $state = 1;
	} elsif ($text =~ /^[^<>]*<\/(timex|numex|enamex)>[^<>]*$/){
	    die "sync error ${type}_out=1 $p[$i]\n";
	} else {
	    die "Poorly handled case ${type}_out=1 $text\n"
		if ($text =~ /[<>]/);
	}
    } else {
	if ($text =~ /^[^<>]*<(timex|numex|enamex)[^>]+>[^<>]*$/){
	    die "sync error case ${type}_out=0 $p[$i]\n";
	} elsif ($text =~ /^[^<>]*<\/(timex|numex|enamex)>[^<>]*$/){
	    $state = 1;
	} else {
	    die "Poorly handled case ${type}_out=0 $text\n"
		if ($text =~ /[<>]/);
	}
    }
}
