 /* File alstoi2r.c */

#if !defined(COMPILE_ENVIRONMENT)
#include <gp/stdcenvf.h> /* std compile environment for functions */
#endif

  void alignment_s_to_ir(ALIGNMENT_INT *pia1, ALIGNMENT_CHR *psa1, pcodeset *pcode1,
     TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms, int *perr)
 /**********************************************************************/
 /*                                                                    */
 /*    Converts the character string alignment *psa1 into an           */
 /* integer alignment *psa1, using pcode *pcode1 and sypplying the     */
 /* encoding function with TTP parameters *ttp_pcdrls_parms in case    */
 /* it has to make up some new word pronunciations.                    */
 /*                                                                    */
 /*   *perr = 0 means a.o.k.                                           */
 /*           1 means encoding error                                   */
 /*           2 means pia1->aligned == T, but na != nb                 */
 /*                                                                    */
 /**********************************************************************/

{
/* local data: */
  char *proc = " alignment_s_to_ir";
/* code: */
 db_enter_msg(proc,3); /* debug only */
/* initialize */
  *perr=0;
/* go */
  pia1->aligned = psa1->aligned;
  encode2r(psa1->pastr,pcode1,ttp_pcdrls_parms,&(pia1->aint[0]),&(pia1->aint[0]),perr);
  if (*perr > 0)
    {fprintf(stderr,"*ERR:%s: encode2r returns *perr=%d\n",proc,*perr);
     fprintf(stderr," trying to encode '%s'\n",psa1->pastr);
     fprintf(stderr," using pcode '%s'\n",pcode1->name);
     *perr = 1;
     goto RETURN;}
  encode2r(psa1->pbstr,pcode1,ttp_pcdrls_parms,&(pia1->bint[0]),&(pia1->bint[0]),perr);
  if (*perr > 0)
    {fprintf(stderr,"*ERR:%s: encode2r returns *perr=%d\n",proc,*perr);
     fprintf(stderr," trying to encode '%s'\n",psa1->pbstr);
     fprintf(stderr," using pcode '%s'\n",pcode1->name);
     *perr = 1;
     goto RETURN;}
  if ((pia1->aligned) && (pia1->aint[0] != pia1->bint[0]))
    {fprintf(stderr,"*ERR:%s: psa1 is supposed to be aligned, but\n",proc);
     fprintf(stderr," length(aint) NOT = length(bint).\n");
     *perr = 11;
     goto RETURN;
    } /* "if (pia1->aligned ... " */
 RETURN:
 db_leave_msg(proc,3); /* debug only */
  } /* end of function "alignment_s_to_ir" */
 /* end file alstoi2r.c */
