/* file fcndcls.h              */
/* local function declarations */
/* export version - stripped of all functions not relevant to aldistsm() */

#ifndef FCNDCLS_HEADER
#define FCNDCLS_HEADER

extern int            add_pcode_element(pcodeset *p1, pcode_element *px, int *perr);
extern char          *adjust_type_case(char *s, pcodeset *pcode);
extern int            aldist_static(ALIGNMENT_INT *pal, int *perr);
extern int            aldist2(ALIGNMENT_INT *pt1, int (*w) (int, int, pcodeset *, int *), int return_alignment, ALIGNMENT_INT *pt2, int *perr);
extern void           aln_i_to_s_fancy2(ALIGNMENT_INT *pia1, ALIGNMENT_CHR *psa1, int *perr);
extern void           alignment_s_to_ir(ALIGNMENT_INT *pia1, ALIGNMENT_CHR *psa1, pcodeset *pcode1,TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms, int *perr);
extern void           alignment_s_to_i3(void (*encode) (char*,pcodeset*,int*,int*,int*),ALIGNMENT_INT *pia1, ALIGNMENT_CHR *psa1, pcodeset *pcode1, int *perr);
extern char          *apply_rules2(char *pb, char *pa, RULESET2 *rset, int *perr);
extern char          *ascii_str(char *sx, PCIND_T ichr, pcodeset *pcode, ALIGNMENT_INT *pal);
extern boolean        atobool(char *s);
extern char          *bool_print(boolean x);
boolean               bound(char c);
extern boolean        boundary_mark(int i, pcodeset *pcdp);
extern char          *build_key3(char *key, char *le, char *tg, char *re, char tgbound);
extern void          *calloc_safe(size_t nobj, size_t size, char *calling_proc);
extern char          *char_name(char *sx, char character);
extern ALIGNMENT_INT *copy_int_al(ALIGNMENT_INT *p2, ALIGNMENT_INT *p1);
extern boolean        consonantal(int i, pcodeset *pcdp);
extern boolean        coronal(char c);
extern void           db_enter_msg(char *proc, int level);
extern void           db_leave_msg(char *proc, int level);
extern void           decode2(char *psex, int lpsex, pcodeset *pc1, int *psinin, int *plinin, int *perr);
extern char          *del_eol(char *ps);
extern void           dump_auxtab(ALIGNMENT_INT *pal);
extern void           dump_bpaths(struct BPATH *bpath);
extern void           dump_code_table(TABLE_OF_CODESETS *ps1);
extern void           dump_hash_pars(HASH_PARAMETERS *hpars);
extern void           dump_int_alignment(ALIGNMENT_INT *p1);
extern void           dump_int_alignment4(ALIGNMENT_INT *paln);
extern void           dump_pcode2(pcodeset *p1);
extern void           dump_pcode3(pcodeset *p1);
extern void           dump_ppf2(pcodeset *pcode);
extern void           dump_pron2(struct PRON2 *pron);
extern void           dump_syl_parms(struct SYL_PARMS *syl_parms);
extern void           dump_words(struct WORD1 *word, int nwords);
extern void           dump_sylbs(struct SYLB1 *sylb, int nsylbs);
extern void           encode_lcs(pcodeset *p1, int *perr);
extern void           encode2(char *psex_in, pcodeset *pcstr, int *psinin, int *plinin, int *perr);
extern void           encode2r(char *sex, pcodeset *pcstr, TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms,int *sinin, int *plinin, int *perr);
extern char          *expenv(char *s, int slength);
extern void           fatal_error(char *reporting_procedure, char *msg, int error_level);
extern int            find_key3(char *pi_tg, int *ib_found, pcodeset *pcdrls, struct BPATH *bpath);
extern void           find_next_token2(SUBSTRING *x, SUBSTRING *y);
extern void           fold_tiers2(WCHAR_T *sint, struct PRON2 *pron, int *lmark, int *rmark, int *wbound);
extern void           free_al_chr(ALIGNMENT_CHR *p);
extern void           free_al_int(ALIGNMENT_INT *p);
extern void           free_bpath1(struct BPATH *bpath);
extern void           free_code_table(TABLE_OF_CODESETS *p);
extern void           free_pcode(pcodeset *p);
extern void           free_rules2(RULESET2 *rset);
extern void           free_str(char *s);
extern void           free_syl_parms2(struct SYL_PARMS *syl_parms);
boolean               fric1(char *p);
extern void           get_bpath_from_pcdrls1(struct BPATH *bpath,pcodeset *pcdrls,char tgbound,int *perr);
extern void           get_code_table(TABLE_OF_CODESETS *ps1, char *fname, int *perr);
extern void           get_comment_flag(char *s, char *comment_flag);
extern void           get_next_alignment_chr(FILE *cfp, ALIGNMENT_CHR *palc1, int *p_at_end);
extern void           get_nstr_table(int **tab, int *n, int nmax, char *fname,pcodeset *pcode, char *comment_flag, int *perr);
extern void           get_pcode3(pcodeset *p1, char *path, char *fname, int *perr);
extern void           get_pcode_element(char *pline, int compositional, pcode_element *px, int *perr);
extern void           get_ppfcn2(ppfcn *ppf, char *fname, pcodeset *pcode, int *perr);
extern void           get_rules2(RULESET2 *rset, char *path, char *fname, int *perr);
extern int            hash(char *key, HASH_PARAMETERS *hpars, int table_length);
extern void           hash_init(HASH_PARAMETERS *hpars);
extern void           init_al_chr(ALIGNMENT_CHR *palc1);
extern void           init_al_int(ALIGNMENT_INT *paln1, pcodeset *pcode1);
extern void           init_pc_table(pcodeset *p1);
extern void           init_pcdrls(pcodeset *pcdrls, int max_ncodes, boolean hashed);
extern boolean        isvowel1(char c);
extern boolean        isvowel2(char c);
extern boolean        iscons1(char c);
extern boolean        iscons2(char c);
extern boolean        is_front_vowel(char c);
extern int           *lc_istr(int *sx, int ichr, pcodeset *pcode, ALIGNMENT_INT *pal);
extern ALIGNMENT_CHR *make_al_chr(void);
extern ALIGNMENT_INT *make_al_int(pcodeset *pcode1);
extern void           make_basic_int_al(ALIGNMENT_INT *alnx);
extern void           make_basic_pron4(struct PRON2 *pron, char *sx,struct SYL_PARMS *syl_parms, int *perr);
extern pcode_element *make_element(pcode_element *px, char *symb, pcodeset *pc1);
extern pcode_element *make_elementr(pcode_element *px, char *symb,pcodeset *pc1, TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms);
extern char          *make_full_fname(char *sx, char *path, char *fname);
extern char          *make_lower(char *s);
extern void           make_pcd_from_rls_file(pcodeset *pcdrls,char *fname_pcdrls,char *path, char tgbound, int *perr);
extern char          *make_upper(char *s);
extern void           make_pc_table(pcodeset *p1);
extern void          *malloc_safe(size_t size, char *calling_proc);
extern boolean        no_word_boundl(WCHAR_T *bnd_int, struct INTERVAL1 cluster, int iwordbound);
extern boolean        no_word_boundr(WCHAR_T *bnd_int, struct INTERVAL1 cluster, int iwordbound);
extern int           *nstrcpy(int *pn_to, int *pn_from);
extern int           *nstrcpyn(int *pn_to, int *pn_from, int nmax);
extern int           *nstrcat(int *pn_to, int *pn_from);
extern int           *nstrdup(int *pn);
extern int           *nstrdup_safe(int *pn, char *calling_proc);
extern boolean        nstreq(int *pn1, int *pn2);
extern int            nstrcmp(int *pn1, int *pn2);
extern int            ntokens(char *s);
extern boolean        ok_final_cluster2(WCHAR_T *aint, struct INTERVAL1 cluster, struct SYL_PARMS *syl_parms);
extern boolean        ok_init_cluster2(WCHAR_T *aint, struct INTERVAL1 cluster, struct SYL_PARMS *syl_parms);
extern int            overlap1(struct INTERVAL1 a, struct INTERVAL1 b);
extern char          *pad_words_with_space(char *out, int out_lim,char *in, int npad);
extern void           parse_rule_key(SUBSTRING *ss_le, SUBSTRING *ss_tg, SUBSTRING *ss_re,char *rkey, char tgbound);
extern int            pc_htab_store(pcodeset *pc1, pcode_element *element, int *duplicate_key, int *table_full);
extern int            pcindex_htab_lookup(char *symb, pcodeset *pc1, int *found);
extern int            pcodeset_misorders(pcodeset *pc1);
extern PCIND_T        pcindex2(char *phone, pcodeset *pc1);
extern PCIND_T        pcindex2r(char *symbol, pcodeset *pc1,TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms);
extern PCIND_T        pcindex_bsearch(char *astr, pcodeset *pc1);
extern PCIND_T        pcindex5(char *symb, pcodeset *pc1, int add_to_core, int add_to_file);
extern void           pcsort1(pcodeset *p1);
extern char          *pltrim(char *s);
extern char          *pltrimf(char *s);
extern char          *prtrim(char *s);
extern char          *prtrim2(char *s);
extern void           process_pcode_aux_line(pcodeset *p1, char *pline, int *perr);
extern void           process_pcode_data_line(pcodeset *p1, char *pline, int *perr);
extern boolean        pronounceable_phon(char *ph, struct SYL_PARMS *syl_parms);
extern void           put_sm_into_aln(ALIGNMENT_INT *pal, SM_TAB_STR2 *smtab, int *perr);
extern void           rate_sm(SM_ELEMENT2 *smrep, ALIGNMENT_INT *pal1);
extern void           read_syl_parms(struct SYL_PARMS *syl_parms, int *perr);
extern char          *remove_comments(char *s, char *comment_flag);
extern char          *remove_diacritics(char *out, char *in);
extern void           remove_zeros(WCHAR_T *s);
extern void           report_lex_add2(int i, pcodeset *pc1, int *perr);
extern char          *safe_print(char *s);
boolean               short_env(char *p);
extern char          *simplify_null_reps(char *s);
extern void           sort_pcodeset_a(pcodeset *p1);
extern void           sort_sm_by_iloc(SM_TAB_STR2 *smtab);
extern char          *spell_mode(char *sph, SUBSTRING *ss_token);
extern SUBSTRING      sstok(SUBSTRING *ssx, char *delimiters);
extern SUBSTRING      sstok2(char *sx, char *delimiters);
extern SUBSTRING      sstok4(char *x);
extern SUBSTRING      sstok_lr_s(char *sx, char lbound, char rbound,boolean include_bounds);
extern boolean        stranded_segment(struct PRON2 *pron);
extern char          *strdup_safe(char *ps, char *calling_proc);
extern boolean        stress_mark(int i, pcodeset *pcdp);
extern char          *strmap1(char *s, char *x, char *y);
extern int            substr_length(SUBSTRING *substr);
extern char          *substr_to_str(SUBSTRING *substr, char *str, int lmax);
extern boolean        string_equal(char *cs, char *ct, int ignore_case);
extern int            strcmpi(char *ps1, char *ps2);  /* BCD 4.2; not TURBO C */
extern int            strncmpi(char *ps1, char *ps2, int n);  /* BCD 4.2; not TURBO C */
extern char          *strcutl(char *ps, int n);
extern char          *strcutr(char *ps, int n);
extern boolean        suprasegmental(int i, pcodeset *pcdp);
extern boolean        syllabic(int i, pcodeset *pcdp);
extern int            textlen(char *s);
extern char          *ttp_prep1(char *out, char *in);
extern char          *ttp1(char *stx, char *sp, int *perr);
extern char          *ttp1s(char *stx, char *sp, int *perr);
extern char          *ttp3s(char *sp, char *st, TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms, int *perr);
extern char          *ttpj1(char *stx, char *sp, int *perr);
extern char          *ttpspan2(char *stx, char *sp, char *path, int *perr);
extern char          *ttp_pcdrls2ss(char *sp, SUBSTRING *sst_in, pcodeset *pcdrls,struct BPATH *bpath,int *perr);
extern boolean        unstressed(struct SYLB1 *sylb, pcodeset *pcdp);
extern boolean        valid_data_line(char *s, char *comment_flag);
boolean               velar(char c);
boolean               voiced(char *p);
extern void           warn_if_add_file(char *fname, char *time);
extern int            wod2(int i, int j, pcodeset *pcij, int *perr);
extern char          *wbtrim(char *s);
extern void           zapchar(char *text, char zapped);

#endif
/* end file fcndcls.h        */
