/* file mbalint.c */

#if !defined(COMPILE_ENVIRONMENT)
#include <gp/stdcenvf.h> /* std compile environment for functions */
#endif

void make_basic_int_al(ALIGNMENT_INT *alnx)
/********************************************************************/
/* Reduces aint[] and bint[] to strings of non-zero, non-aux words. */
/********************************************************************/
{char *proc = "make_basic_int_al";
 int i,j,k,iaux,n;
 int ax[MAX_SYMBS_IN_STR+1], bx[MAX_SYMBS_IN_STR+1];
db_enter_msg(proc,1); /* debug only */
/* remove null elements */
 remove_zeros(alnx->aint);
 remove_zeros(alnx->bint);
 alnx->aligned = F;
 /* expand aux symbols */
 nstrcpy(ax,alnx->aint);
 j = 0;
 if (alnx->naux > 0)
   {for (i = 1; i <= ax[0]; i++)
      {if (ax[i] > alnx->pcset->pctab_length)
         {/* word defined in aux tab */
          iaux = ax[i] - alnx->pcset->pctab_length;
          if (iaux > alnx->naux)
            {fprintf(stderr,"*ERR:%s: iaux=%d,naux=%d\n",proc,iaux,alnx->naux);
             continue;
            }
          n = alnx->auxtab[iaux][0];
          for (k=1; k <= n; k++) alnx->aint[++j] =  alnx->auxtab[iaux][k];
         }
       else alnx->aint[++j] = ax[i]; /* regular word */
       alnx->aint[0] = j; /* remember new aint[] length */
      }
    nstrcpy(bx,alnx->bint);
    j = 0;
    for (i = 1; i <= bx[0]; i++)
      {if (bx[i] > alnx->pcset->pctab_length)
         {/* word defined in aux tab */
          iaux = bx[i] - alnx->pcset->pctab_length;
          n = alnx->auxtab[iaux][0];
          for (k=1; k <= n; k++) alnx->bint[++j] = alnx->auxtab[iaux][k];
         }
       else alnx->bint[++j] = bx[i]; /* regular word */
       alnx->bint[0] = j; /* remember new bint[] length */
   }  }
db_leave_msg(proc,1); /* debug only */
 return;
}
