/* file ttp3s.c  */

#if !defined(COMPILE_ENVIRONMENT)
#include <gp/stdcenvf.h> /* std compile environment for functions */
#endif


  char *ttp3s(char *sp, char *st, TTP_PCDRLS_PARAMETERS *ttp_pcdrls_parms, int *perr)
  /*********************************************/
  /*  Converts text to phones                  */
  /*   Input: *st is an ASCII text string;     */
  /*  Output: *sp is an ASCII phone string;    */
  /*   (Returns sp.)                           */
  /*  Process: applies ttp rules that are in   */
  /* the *ttp_pcdrls_parms, defaulting to      */
  /* spell-mode if result is unpronounceable.  */
  /*  On return, *perr > 0 iff error.          */
  /*********************************************/
   {char *proc = "ttp3s";
    char *the_rest;
    char tkx[LINE_LENGTH], *token_pron = &tkx[0];
    SUBSTRING sstkx, *ss_token = &sstkx;
/* code */
 db_enter_msg(proc,1); /* debug only */
if (db_level > 2) printf("%sinput='%s'\n",pdb,st);
    *perr = 0;
   /* empty output string */
    sp = strcpy(sp,"");
   /* loop on tokens in input */
    the_rest = st;
    do
      {*ss_token = sstok4(the_rest);
       if (substr_length(ss_token) < 1) continue;
      /* generate pron using TTP rules */
       token_pron = ttp_pcdrls2ss(token_pron,ss_token,
         ttp_pcdrls_parms->pcdrls,ttp_pcdrls_parms->bpath,perr);
       if (*perr > 0) goto RETURN;
       zapchar(token_pron,'*'); /* mark of deletion by pcdrls */
      /* if result not pronounceable, say it in spell mode */
       if (!pronounceable_phon(token_pron,ttp_pcdrls_parms->syl_parms))
         token_pron = spell_mode(token_pron,ss_token);
       sp = strcat(sp,token_pron);
       the_rest = ss_token->end + 1;
      }
    while (substr_length(ss_token) > 0);
   RETURN:
if (db_level > 2) printf("%soutput='%s'\n",pdb,sp);
 db_leave_msg(proc,1); /* debug only */
    return sp;
   }
