/* file ttp_pcdrls2ss.c */

#if !defined(COMPILE_ENVIRONMENT)
#include <gp/stdcenvf.h> /* std compile environment for functions */
#endif

char *ttp_pcdrls2ss(char *sp, SUBSTRING *sst_in, pcodeset *pcdrls,
  struct BPATH *bpath,int *perr)
 
  /*********************************************/
  /*  Converts text to phones w/pcdrls table   */
  /* INSTRUMENTED VERSION TO COUNT HITS & NO-HITS */
  /*  Input:  *sst_in is a text string;        */
  /*  Output: *sp is a phone string;           */
  /*  (Returns sp.)                            */
  /*  Process: applies ttp rules that are in   */
  /*  the form of pcodeset *pcdrls.            */
  /*  On return, *perr > 0 iff error.          */
  /*  *perr == 1 iff invalid char              */
  /*********************************************/
   {char *proc = "ttp_pcdrls2ss";
    char stxx1[LONG_LINE], *st_in = &stxx1[0];
    char stxx2[LONG_LINE], *st = &stxx2[0];
    char *pi;
    int ib, item, npad = 8;
  /* code */
 db_enter_msg(proc,1); /* debug only */
    *perr = 0;
   /* pad word tokens w/space to cover initial le and final re */
    st_in = substr_to_str(sst_in,st_in,LONG_LINE);
    st = pad_words_with_space(st,LONG_LINE,st_in,npad);

if (db_level > 1)
 {printf("%stext='%s'\n",pdb,st);
 }
   /* empty output string */
    sp = strcpy(sp,"");
   /* apply rules encoded in pcdrls */
    pi = st;
    while (*pi != '\0')
      {item = find_key3(pi,&ib,pcdrls,bpath);
       if (item >= 0)
         {sp = strcat(sp,pcdrls->pc[item].lc_ext);
if (db_level > 1) printf("%s pcdrls->pc[item].ac=[%s]\n",pdb,pcdrls->pc[item].ac);
if (db_level > 1) printf("%s pcdrls->pc[item].lc_ext=[%s]\n",pdb,pcdrls->pc[item].lc_ext);
          pi += bpath->rpart[ib].tg;
if (db_level > 1) printf("%s hit, new sp=[%s]\n",pdb,sp);
         }
       else
         {pi += 1;
if (db_level > 1) printf("%s no hit\n",pdb);
      }  }  
if (db_level > 1) printf("%s leaving ttp, output='%s'\n",pdb,sp);

  db_leave_msg(proc,1); /* debug only */
    return sp;
   }
